#*************************************************************
# Progamm:			isa_atmosphaere
# Sinn des Programms: 		Einlesen und Interpolieren sowie Errechnen von
#				athmosphärischen Zustandsgrößen aus einer Tabelle	
# Sinn der Einheit  :		Ausgabeeinheit	
# Name dieser Datei:		ausgabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		isa_atmosphaere_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	5
# von:				5			
# Autor: 			Armin Ulrich
# Erster Lauf: 			30.06.2021
# Letzte Änderung: 		31.07.2021
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateiauslesung
#*************************************************************
import os

#*************************************************************
# Import der Klasse matplotlib.pyplot für die Graphikausgabe
#*************************************************************
import matplotlib.pyplot as plt
#import numpy as np

class Ausgabe:
  #Konstruktormethode
  def __init__(self):		
    print("Ausgabeobjekt erzeugt")
    

  #Destruktormethode
  def __del__(self):	
    print("Ausgabeobjekt entfernt")  
  
  #Funktion zum Auflösen der Benutzeroberfläche
  def ende(self):
    self.ausgabe_gui.destroy()
    
    
    
  def schirm_ausgabe_einzel(self,h, T_interpoliert, T_formel,  p_interpoliert,  p_formel, rho_relativ_interpoliert, rho_relativ_formel, nue_interpoliert, nue_formel,a_interpoliert, a_formel ):
    print("Schirmausgabe")  
    print("Höhe [m]:",h)
    print("\t\tTemperatur[K]:\tDruck[pa]:\trelative Dichte[-]:\tkinematische Zähigkeit[m²/s]:\tSchallgeschwindigkeit [m/s]:")
    print("Interpoliert: \t","{0:.2f}".format(T_interpoliert),"\t","{0:.2f}".format(p_interpoliert),"\t","{0:.5f}".format(rho_relativ_interpoliert),"\t","\t",\
    "{0:.7f}".format(nue_interpoliert),"\t","\t","\t","{0:.2f}".format(a_interpoliert))
    print("Aus Formel: \t","{0:.2f}".format(T_formel),"\t","{0:.2f}".format(p_formel),"\t","{0:.5f}".format(rho_relativ_formel),"\t","\t","{0:.7f}".format(nue_formel),\
    "\t","\t","\t","{0:.2f}".format(a_formel))
    
    
  def schirm_ausgabe_tabelle(self,m,höhe,T_tabelle ,T_formel,p_tabelle ,p_formel,rho_relativ_tabelle, rho_relativ_formel,nue_tabelle ,nue_formel,a_tabelle ,a_formel):  
    print()
    print("i [-]\tHöhe [m]:\tTemperatur[K]:\t\t\tDruck[pa]:\t\t\trelative Dichte[-]:\t\tkinematische Zähigkeit[m²/s]:\tSchallgeschwindigkeit [m/s]:")
    print("\t\t\tinterpoliert\taus Formel\tinterpoliert\taus Formel\tinterpoliert\taus Formel\tinterpoliert\taus Formel\tinterpoliert\taus Formel\t")
    for i in range(m):
      print("{:5d}".format(i),"\t","{:5.5f}".format(höhe[i]),"\t","{:3.2f}".format(T_tabelle[i]),"\t" ,"{:3.2f}".format(T_formel[i]),"\t","{:6.2f}".format(p_tabelle[i]),"\t" ,\
      "{:6.2f}".format(p_formel[i]),"\t","{:1.5f}".format(rho_relativ_tabelle[i]),"\t" ,"{:1.5f}".format(rho_relativ_formel[i]), "\t" ,"{:1.7f}".format(nue_tabelle[i]),"\t" ,\
      "{:1.7f}".format(nue_formel[i]), "\t" ,"{:3.2f}".format(a_tabelle[i]),"\t" ,"{:3.2f}".format(a_formel[i]))
      
    
    
  def datei_ausgabe_einzel(self, ausgabe_datei_einzel, h,  T_interpoliert, T_formel,  p_interpoliert,p_formel,  rho_relativ_interpoliert, rho_relativ_formel, nue_interpoliert,\
    nue_formel,a_interpoliert, a_formel ):
    fobj_out = open(ausgabe_datei_einzel,"w")
    fobj_out.write("Höhe [m] :")
    fobj_out.write("\t")
    fobj_out.write(f"{h:.0f}")
    fobj_out.write("\n")
    fobj_out.write("\t")
    fobj_out.write("\t")
    fobj_out.write("Temperatur [K]:")
    fobj_out.write("\t")
    fobj_out.write("Druck [pa]:")
    fobj_out.write("\t")
    fobj_out.write("relative Dichte [-]:")
    fobj_out.write("\t")
    fobj_out.write("kinematische Zähigkeit [m²/s]:")
    fobj_out.write("\t")
    fobj_out.write("Schallgeschwindigkeit [m/s]:")
    fobj_out.write("\n")
    fobj_out.write("Interpoliert: ")
    fobj_out.write("\t")
    fobj_out.write(f"{T_interpoliert:.3f}")
    fobj_out.write("\t")
    fobj_out.write("\t")
    fobj_out.write(f"{p_interpoliert:.3f}")
    fobj_out.write("\t")
    fobj_out.write(f"{rho_relativ_interpoliert:.3f}")
    fobj_out.write("\t")
    fobj_out.write("\t")
    fobj_out.write("\t")
    fobj_out.write(f"{nue_interpoliert:.7f}")
    fobj_out.write("\t")
    fobj_out.write("\t")
    fobj_out.write("\t")
    fobj_out.write(f"{a_interpoliert:.3f}")
    fobj_out.write("\n")
    fobj_out.write("Aus Formel: ")
    fobj_out.write("\t")
    fobj_out.write(f"{T_formel:.3f}")
    fobj_out.write("\t")
    fobj_out.write("\t")
    fobj_out.write(f"{p_formel:.3f}")
    fobj_out.write("\t")
    fobj_out.write(f"{rho_relativ_formel:.3f}")
    fobj_out.write("\t")
    fobj_out.write("\t")
    fobj_out.write("\t")
    fobj_out.write(f"{nue_formel:.7f}")
    fobj_out.write("\t")
    fobj_out.write("\t")
    fobj_out.write("\t")
    fobj_out.write(f"{a_formel:.3f}")
    fobj_out.close()  
    
  def datei_ausgabe_tabelle(self,ausgabe_datei,m,höhe,T_tabelle ,T_formel,p_tabelle ,p_formel,rho_relativ_tabelle, rho_relativ_formel,nue_tabelle,nue_formel,a_tabelle ,a_formel):
    fobj_out = open(ausgabe_datei,"w")
    fobj_out.write("i")
    fobj_out.write("\t")
    fobj_out.write("Höhe")
    fobj_out.write("\t")
    fobj_out.write("T Tabelle")
    fobj_out.write("\t")
    fobj_out.write("T_Formel")
    fobj_out.write("\t")
    fobj_out.write("p Tabelle")
    fobj_out.write("\t")
    fobj_out.write("p_Formel")
    fobj_out.write("\t")
    fobj_out.write("rho_relativ Tabelle")
    fobj_out.write("\t")
    fobj_out.write("rho_relativ_Formel")
    fobj_out.write("\t")
    fobj_out.write("nue Tabelle")
    fobj_out.write("\t")
    fobj_out.write("nue_Formel")
    fobj_out.write("\t")
    fobj_out.write("a Tabelle")
    fobj_out.write("\t")
    fobj_out.write("a_Formel")
    fobj_out.write("\n")
    for i in range(m):
      fobj_out.write(f"{i:2}")
      fobj_out.write("\t")
      fobj_out.write(f"{höhe[i]:.1f}") 
      fobj_out.write("\t")
      fobj_out.write(f"{T_tabelle[i]:.2f}")              
      fobj_out.write("\t")
      fobj_out.write("\t")
      fobj_out.write(f"{T_formel[i]:.2f}") 
      fobj_out.write("\t")
      fobj_out.write("\t")
      fobj_out.write(f"{p_tabelle[i]:.0f}")              
      fobj_out.write("\t")
      fobj_out.write("\t")
      fobj_out.write(f"{p_formel[i]:.0f}") 
      fobj_out.write("\t")
      fobj_out.write("\t")
      fobj_out.write(f"{rho_relativ_tabelle[i]:.5f}")              
      fobj_out.write("\t")
      fobj_out.write("\t")
      fobj_out.write("\t")
      fobj_out.write(f"{rho_relativ_formel[i]:.5f}") 
      fobj_out.write("\t")
      fobj_out.write("\t")
      fobj_out.write("\t")
      fobj_out.write(f"{nue_tabelle[i]:.7f}")              
      fobj_out.write("\t")
      fobj_out.write(f"{nue_formel[i]:.7f}") 
      fobj_out.write("\t")
      fobj_out.write(f"{a_tabelle[i]:.2f}")              
      fobj_out.write("\t")
      fobj_out.write("\t")
      fobj_out.write(f"{a_formel[i]:.2f}") 
      fobj_out.write("\n")
    fobj_out.close() 
    
  def gui_ausgabe(self,h,  T_interpoliert, T_formel,  p_interpoliert, p_formel,  rho_relativ_interpoliert,rho_relativ_formel,  nue_interpoliert, nue_formel,  a_interpoliert, a_formel):
    import tkinter
    self.ausgabe_gui = tkinter.Tk()
    tkinter.Label(self.ausgabe_gui, text='%s'%(" "), borderwidth=1 ).grid(row=0,column=0)
    tkinter.Label(self.ausgabe_gui, text='%s'%("Höhe [m]"), borderwidth=1 ).grid(row=0,column=1)
    tkinter.Label(self.ausgabe_gui, text='%s'%("Temperatur [K]"), borderwidth=1 ).grid(row=0,column=2)
    tkinter.Label(self.ausgabe_gui, text='%s'%("Druck [pa]"), borderwidth=1 ).grid(row=0,column=3)
    tkinter.Label(self.ausgabe_gui, text='%s'%("relative Dichte [-]"), borderwidth=1 ).grid(row=0,column=4)
    tkinter.Label(self.ausgabe_gui, text='%s'%("kinematische Zähigkeit [m²/s]"), borderwidth=1 ).grid(row=0,column=5)
    tkinter.Label(self.ausgabe_gui, text='%s'%("Schallgeschwindigkeit [m/s]"), borderwidth=1 ).grid(row=0,column=6)   
    tkinter.Label(self.ausgabe_gui, text='%s'%("Nach Interpolation"), borderwidth=1 ).grid(row=1,column=0)
    tkinter.Label(self.ausgabe_gui, text='%s'%("Nach Formel"), borderwidth=1 ).grid(row=2,column=0)
    
    tkinter.Label(self.ausgabe_gui, text='%s'%(str(h)), borderwidth=1 ).grid(row=1,column=1)
    tkinter.Label(self.ausgabe_gui, text='%s'%(str(h)), borderwidth=1 ).grid(row=2,column=1)
    tkinter.Label(self.ausgabe_gui, text='%s'%(str(round(T_interpoliert,2))), borderwidth=1 ).grid(row=1,column=2)
    tkinter.Label(self.ausgabe_gui, text='%s'%(str(round(T_formel,2))), borderwidth=1 ).grid(row=2,column=2)
    tkinter.Label(self.ausgabe_gui, text='%s'%(str(round(p_interpoliert,1))), borderwidth=1 ).grid(row=1,column=3)
    tkinter.Label(self.ausgabe_gui, text='%s'%(str(round(p_formel,1))), borderwidth=1 ).grid(row=2,column=3)
    tkinter.Label(self.ausgabe_gui, text='%s'%(str(round(rho_relativ_interpoliert,5))), borderwidth=1 ).grid(row=1,column=4)
    tkinter.Label(self.ausgabe_gui, text='%s'%(str(round(rho_relativ_formel,5))), borderwidth=1 ).grid(row=2,column=4)
    tkinter.Label(self.ausgabe_gui, text='%s'%(str(round(nue_interpoliert,8))), borderwidth=1 ).grid(row=1,column=5)
    tkinter.Label(self.ausgabe_gui, text='%s'%(str(round(nue_formel,8))), borderwidth=1 ).grid(row=2,column=5)
    tkinter.Label(self.ausgabe_gui, text='%s'%(str(round(a_interpoliert,2))), borderwidth=1 ).grid(row=1,column=6)
    tkinter.Label(self.ausgabe_gui, text='%s'%(str(round(a_formel,2))), borderwidth=1 ).grid(row=2,column=6)
    
    b = tkinter.Button(self.ausgabe_gui, text = "weiter", command = self.ende )
    b.grid(row=3, column=0, padx='1', pady='1', sticky='ew')
   
    
  #Endlosschleife
    self.ausgabe_gui.mainloop()  
    
  #*************************************************************
# Funktion zur graphischen Ausgabe
#*************************************************************
#  def graphik_ausgabe_T(self,m, h, größe, graphik_datei_ausgabe_wähler,graphik_datei_name, graphik_datei_format):
  def graphik_ausgabe(self,m, höhe, größe, größe_formel, graphik_datei_ausgabe_wähler,graphik_datei_name, graphik_format, titel, y_achse):
    höhe_min=0.0
    höhe_max=0.0
    größe_min=0.0
    größe_max=0.0
    i_max = m - 1
    for i in range(i_max+1):
      if höhe_min >= höhe[i]:
        höhe_min = höhe[i]
      if höhe_max <= höhe[i]:
        höhe_max = höhe[i]
      if größe_min >= größe[i]:
        größe_min = größe[i]
      if größe_max <= größe[i]:
        größe_max = größe[i]
      if größe_min >= größe_formel[i]:
        größe_min = größe_formel[i]
      if größe_max <= größe_formel[i]:
        größe_max = größe_formel[i] 
    plt.plot(höhe, größe_formel,  'b.',label=r'Nach Formel')     
    plt.plot(höhe, größe, 'r.',label=r'Nach Interpolation')
   
      # Achsen-Bereiche manuell festlegen
    
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
    höhe_min-=(höhe_max-höhe_min)/10.0
    höhe_max+=(höhe_max-höhe_min)/10.0
    größe_min-=(größe_max-größe_min)/10.0
    größe_max+=(größe_max-größe_min)/10.0
    plt.axis([höhe_min, höhe_max, größe_min, größe_max])
    plt.title(titel )
    plt.xlabel("höhe [m]")
    plt.ylabel(y_achse)
    plt.legend(loc='upper right', frameon=True)
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    if(graphik_datei_ausgabe_wähler):
      try:
        plt.savefig(graphik_datei_name + '.' + graphik_format, format=graphik_format) 
      except:
        print("Graphikdateiformat",graphik_datei_format ,"wird nicht von python unterstützt") 
        print(" unterstützt werden die Formate:",{'eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'} )
     # Diagramm anzeigen:
    plt.show()
  
    
