#*************************************************************
# Progamm:			isa_atmosphaere
# Sinn des Programms: 		Einlesen und Interpolieren sowie Errechnen von
#				athmosphärischen Zustandsgrößen aus einer Tabelle	
# Sinn der Einheit  :		Eingabeeinheit	
# Name dieser Datei:		eingabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		isa_atmosphaere_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	3
# von:				5			
# Autor: 			Armin Ulrich
# Erster Lauf: 			24.02.2021
# Letzte Änderung: 		07.07.2021
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateiauslesung
#*************************************************************
import os

import numpy as np

class Eingabe:
  #Konstruktormethode
  def __init__(self):		
    print("Eingabeobjekt erzeugt")
    

  #Destruktormethode
  def __del__(self):	
    print("Eingabeobjekt entfernt")  


#*************************************************************
# Funktion zum Öffnen der Steuerdatei und zum Auslesen der
# Steuerdaten
#*************************************************************
  def isa_input(self, eingabe_datei):
    print("Einlesen der Atmosphärendaten") 
    self.zeilen_zähler=0
 
#*************************************************************
# Überprüfung ob die Steuerdatei existiert 
#*************************************************************
    if os.path.exists(eingabe_datei):
      fobj_in = open(eingabe_datei,"r") 
      for zeile in fobj_in:
        self.zeilen_zähler += 1
      fobj_in.close()  
      # print("Zeilenzähler =", self.zeilen_zähler)
      
      self.höhe = np.zeros(self.zeilen_zähler)
      self.T = np.zeros(self.zeilen_zähler)
      self.p = np.zeros(self.zeilen_zähler)
      self.rho_relativ = np.zeros(self.zeilen_zähler)
      self.nue = np.zeros(self.zeilen_zähler)
      self.lambada = np.zeros(self.zeilen_zähler)
      self.a = np.zeros(self.zeilen_zähler)
      j = 0
      fobj_in = open(eingabe_datei,"r") 
      for line in fobj_in:
        zeile=line.rstrip()
        länge = len(zeile)
        self.puffer = zeile
        dummy=self.puffer.split("\t")
        self.höhe[j]=float(dummy[0])
        self.T[j]=float(dummy[1])  
        self.p[j]=float(dummy[2])*1e5
        self.rho_relativ[j]=float(dummy[3])  
        self.nue[j]=float(dummy[4]) *1e-5 
        self.lambada[j]=float(dummy[5])*1e-2 
        self.a[j]=float(dummy[6])       
        j+=1      
      fobj_in.close() 
      self.max_zeile = self.zeilen_zähler
      return True 
    else:
      print("Datei ist NICHT vorhanden")
      return False
